#ifndef __MUSICPLAYER_H__
#define __MUSICPLAYER_H__

#include <snd.h>
#include <fcntl.h>
#include "oggplayer.h"

class MusicInfo
{
public:
  string path;
};

class MusicPlayer
{
public:
  MusicPlayer();
  
  void readDir(const char *dirname)
  {
    DIR *dp;
    struct dirent *dirp;
    if((dp = opendir(dirname)) == NULL)
      return;
    
    while((dirp = readdir(dp)) != NULL) {
      char *filename = dirp->d_name;
      char *fileext = strrchr(filename,'.');
      if(!fileext)
        continue;
      if(strcmp(fileext,".mp3") == 0 ||
          strcmp(fileext,".ogg") == 0) {
        string filepath.append(dirname).append("/").append(filename);
        addTrack(filepath.c_str());
      }
    }
    closedir(dp);
  }
  
  addTrack(const char *trackpath)
  {
    MusicInfo *minfo = new MusicInfo();
    minfo.path = trackpath;
    tracks.push_back(minfo);
    if(tracks.size() == 1)
      curtrack = tracks.begin();
  }
  
  

protected:
  vector<MusicInfo*> tracks;
  vector<MusicInfo*>::iterator curtrack;
};


#endif
